Subject: bug#36897: closed (Re: bug#36897: 27.0.50; [CC Mode] c-after-change may signal error in narrowed buffer)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 02 Aug 2019 11:35:02 +0000

Your bug report

#36897: 27.0.50; [CC Mode] c-after-change may signal error in narrowed buffer

which was filed against the emacs, cc-mode package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
36897: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=36897
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#36897: 27.0.50; [CC Mode] c-after-change may signal error in narrowed buffer
From: Alan Mackenzie <[email-masked]>
To: Noam Postavsky <[email-masked]>
Cc: [email-masked]
Date: 2 Aug 2019 10:41:28 -0000
List-Id: <debbugs-submit.debbugs.gnu.org>

In article <[email-masked]> I wrote:

[ .... ]

> I'll commit my patch soon, hopefully today.

I've done this, and I'm closing the bug.

[ .... ]

-- 
Alan Mackenzie (Nuremberg, Germany).

Subject: 27.0.50; [CC Mode] c-after-change may signal error in narrowed buffer
From: Noam Postavsky <[email-masked]>
To: [email-masked]
Date: Thu, 01 Aug 2019 20:30:17 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

Package: emacs, cc-mode

>From 'emacs -Q', eval the following:

(with-current-buffer (get-buffer-create "*test*")
  (erase-buffer)
  (insert "int main()\n{\n  \n}\n")
  (search-backward "\n}")
  (c-mode)
  (save-restriction
    (narrow-to-region (point) (point))
    (insert "foo")))

Gives the backtrace:

Debugger entered--Lisp error: (args-out-of-range 1 1)
  get-text-property(1 c-fl-syn-tab)
  c-clear-string-fences()
  #f(compiled-function () #<bytecode 0xbb39fd>)()
  c-after-change(16 19 0)
  insert("foo")
  (save-restriction (narrow-to-region (point) (point)) (insert "foo"))
  (save-current-buffer (set-buffer (get-buffer-create "*test*")) (erase-buffer) (insert "int main()\n{\n  \n}\n") (search-backward "\n}") (c-mode) (save-restriction (narrow-to-region (point) (point)) (insert "foo")))

This is a reduced test case from
https://github.com/joaotavora/eglot/issues/291.

I think the obvious fix is to extend the save-restriction just a bit
further to cover c-clear-string-fences, patch attached.

>From 2865541594f18898c234a2ed076879ce2f887693 Mon Sep 17 00:00:00 2001
From: Noam Postavsky <[email-masked]>
Date: Thu, 1 Aug 2019 20:14:32 -0400
Subject: [PATCH] Fix c-after-change in narrowed buffer

* lisp/progmodes/cc-mode.el (c-after-change): Include the
c-clear-string-fences call in the save-restriction, so that it has
access to the widened buffer.
---
 lisp/progmodes/cc-mode.el | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

diff --git a/lisp/progmodes/cc-mode.el b/lisp/progmodes/cc-mode.el
index a5e158933b..9df4224448 100644
--- a/lisp/progmodes/cc-mode.el
+++ b/lisp/progmodes/cc-mode.el
@@ -1989,10 +1989,10 @@ c-after-change
       ;; When `combine-after-change-calls' is used we might get calls
       ;; with regions outside the current narrowing.  This has been
       ;; observed in Emacs 20.7.
-      (unwind-protect
-	  (progn
-	    (c-restore-string-fences (point-min) (point-max))
-	    (save-restriction
+      (save-restriction
+	(unwind-protect
+	    (progn
+	      (c-restore-string-fences (point-min) (point-max))
 	      (save-match-data ; c-recognize-<>-arglists changes match-data
 		(widen)
 
@@ -2032,8 +2032,8 @@ c-after-change
 		(save-excursion
 		  (mapc (lambda (fn)
 			  (funcall fn beg end old-len))
-			c-before-font-lock-functions)))))
-	(c-clear-string-fences))))
+			c-before-font-lock-functions))))
+	  (c-clear-string-fences)))))
   ;; A workaround for syntax-ppss's failure to notice syntax-table text
   ;; property changes.
   (when (fboundp 'syntax-ppss)
-- 
2.11.0

In GNU Emacs 27.0.50 (build 23, x86_64-pc-linux-gnu, X toolkit, Xaw scroll bars)
 of 2019-07-30 built on minid
Repository revision: 3a59cc84069376802ba8fd731b524d78db58262c
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.11902000
System Description: Debian GNU/Linux 9 (stretch)

Recent messages:
Error during redisplay: (jit-lock-function 18) signaled (args-out-of-range 1 1)
Continuing.
c-clear-string-fences: Args out of range: 1, 1